pub struct Combinations<I: Iterator> {
    indices: Vec<usize>,
    size: usize,
    pool: Vec<I::Item>,
    first: bool,
}

impl<I: Iterator> Combinations<I> {
    pub fn new(iter: I, comb: usize) -> Self {
        let pool: Vec<I::Item> = iter.collect();

        Self {
            indices: Vec::with_capacity(comb),
            size: pool.len(),
            pool,
            first: true,
        }
    }
}

impl<I: Iterator> Iterator for Combinations<I> {
    type Item = I::Item;

    fn next(&mut self) -> Option<Self::Item> {
        todo!()
    }
}
